/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Overlaid portion of the MaxEd editor                                   *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <ctype.h>
#include <mem.h>
#include <setjmp.h>
#include <string.h>
#include <assert.h>
#include "prog.h"
#include "alc.h"
#include "max.h"
#include "max_msg.h"

static char * pig(char *s,char *temp);

extern struct _msg *mmsg;

extern int cursor_x,
           cursor_y,
           offset,
           usrlen,
           num_quotebuf,
           cur_quotebuf,
           last_quote,
           quotefile;

extern char *update_table,
            *quotebuf,
            last_msg_attr,
            insert,
            initials[],
            pos_to_be_updated,
            skip_update,
            quoting;

extern long *quote_pos;


void pascal MagnEt_Help(void)
{
  Mdm_Flow_On();
  Display_File(0,NULL,PRM(oped_help));
  Fix_MagnEt();
}

void pascal EdMemOvfl()
{
  logit(mem_nmsgb);
  Puts(mem_nmsgb);

  Press_ENTER();

  longjmp(jumpto,-1);       /* I know, I know, I'm ashamed about it too... *
                             * In here, we can return anything but zero.   */
}




void pascal MagnEt_Menu(void)
{
  if (usr.formfeed)
    Puts(CLS);
  else NoFF_CLS();

  Mdm_Flow_On();
  Bored_Menu(mmsg);
  Fix_MagnEt();
}



void pascal Quote_Copy(void)
{
  int ln,
      x;

  char save,
       *s,
       *p,
       *n;

  save=insert;
  insert=TRUE;

  /* Make sure there's nothing in front of us on the current line, and if  *
   * there is, send it to the bit-bucket.                                  */

  for (ln=0;ln < QUOTELINES && num_lines < max_lines-1;ln++)
  {
    if (*(quotebuf+(ln*MAX_LINELEN)) != '\x16')
    {
      /* Add a line */
      if (Allocate_Line(num_lines+1))
        EdMemOvfl();


      /* Now shift everything else down one, so that the new line is       *
       * where we want it to be (the current line).                        */

      p=screen[num_lines];

      for (x=num_lines-1;x >= offset+cursor_x;x--)
      {
        screen[x+1]=screen[x];
        update_table[x+1]=TRUE;
      }

      /* Now put the newly-allocated line right here, after moving         *
       * everything else out of the way...                                 */

      screen[offset+cursor_x]=n=p;

      /* Should be hard-CR delimited */
      *n++=HARD_CR;

      /* Now copy the quote in place */

      *n++=' ';

      for (s=initials;*s;s++)
        *n++=*s;

      *n++='>';
      *n++=' ';

      strcpy(n,quotebuf+(ln*MAX_LINELEN));

      update_table[offset+cursor_x]=TRUE;
      cursor_x++;





/*
      Add_Character(' ');

      for (s=initials;*s;s++)
        Add_Character(*s);

      Add_Character('>');
      Add_Character(' ');

      for (y=0;y < strlen(quotebuf+(x*MAX_LINELEN));y++)
        Add_Character(*(quotebuf+(x*MAX_LINELEN)+y));

      Carriage_Return(TRUE);
*/
    }
    else break;
  }

  if (cursor_x >= usrlen )
    Scroll_Down(SCROLL_CASUAL,cursor_x-SCROLL_CASUAL);

  cursor_y=1;

  insert=save;
}


void pascal Read_DiskFile(void)
{
  extern int linenum;

  FILE *infile;

  char temp[PATHLEN],
       *s,*p;

  int x,y;

  WhiteN();

  OpusGetsL(temp,PATHLEN,s(import_file));

  if (fexist(temp))
  {
    if ((infile=shfopen(temp,fopen_read,O_RDONLY)) != NULL)
    {
      for (y=0;num_lines < max_lines-(BUFSIZ/MAX_LINELEN)-1;y++)
      {
        if (fgets(temp,LINELEN,infile) != NULL)
        {
          Trim_Line(temp);
          
          for (s=temp;*s;s++)
          {
            if (*s < 0x20)
              *s=' ';
            else if (*s > 0x7f && !Highbit_Allowed())
              *s=nohibit[(unsigned char)*s];
          }

          if (Allocate_Line(inmagnet ? num_lines+1 : linenum))
            EdMemOvfl();

          if (inmagnet)
          {
            p=screen[num_lines];

            for (x=num_lines-1;x >= offset+cursor_x+y;x--)
            {
              screen[x+1]=screen[x];

/*            screen[x+1][0]=screen[x][0];
              memmove(screen[x+1]+1,screen[x]+1,strlen(screen[x]+1)+1); */
            }

            screen[offset+cursor_x+y]=p;

            screen[offset+cursor_x+y][0]='\r';
            strcpy(screen[offset+cursor_x+y]+1,temp);
          }
          else
          {
            screen[linenum][0]='\r';
            strcpy(screen[linenum++]+1,temp);
          }
        }
        else break;
      }

      fclose(infile);
    }
  }

  if (inmagnet)
    Redraw_Text();
}


void pascal MagnEt_Bad_Keystroke(void)
{
  Goto(usrlen,1);

  Printf(s(max_no_understand),ck_for_help);

  Goto(cursor_x,cursor_y);

  while (! Mdm_keyp())
    Giveaway_Slice();

  Redraw_StatusLine();
}

void pascal Load_Message(int msgfile)
{
  extern int linenum;

  char outline[MAX_LINELEN],
       linetype[1],
       last_msg_attr,
       *pp[1],
       *p;

  int x,y;

  last_msg_attr=MSGLINE_normal;

  lseek(msgfile,(long)sizeof(struct _msg),SEEK_SET);

  for (y=0;num_lines < max_lines-(BUFSIZ/MAX_LINELEN)-1;)
  {
    pp[0]=outline;
    
    if (Msg_Read_Lines(msgfile,1,usrwidth-(inmagnet ? 1 : 6),pp,linetype,&last_msg_attr) <= 0)
      break;

    if (! (linetype[0] & MSGLINE_kludge))
    {
      /* Stop reading in when we get to the tear line */
 
      if (strnicmp(outline,s(max_tear),16)==0)
        break;


      if (Allocate_Line(inmagnet ? num_lines+1 : linenum))
        EdMemOvfl();

      if (inmagnet)
      {
        p=screen[num_lines];

        for (x=num_lines-1;x >= offset+cursor_x+y;x--)
          screen[x+1]=screen[x];

        screen[offset+cursor_x+y]=p;

        if (linetype[0] & MSGLINE_soft)
          screen[offset+cursor_x+y][0]=SOFT_CR;
        else screen[offset+cursor_x+y][0]=HARD_CR;

        strcpy(screen[offset+cursor_x+y]+1,outline);
      }
      else
      {
        if (linetype[0] & MSGLINE_soft)
          screen[linenum][0]=SOFT_CR;
        else screen[linenum][0]=HARD_CR;

        strcpy(screen[linenum++]+1,outline);
      }

      y++;
    }
  }

  /* Strip any trailing blank lines */

  for (x=inmagnet ? num_lines : linenum-1;x >= 1 && screen[x][1]=='\0';x--)
    Free_Line(num_lines);
}

void pascal Piggy(void)
{
  int x,
      ofs,
      cx,cy;

  char temp[MAX_LINELEN*2],
       temp2[PATHLEN],
       *o,*s,*p,*l;

  if (no_piggy)
    return;

  ofs=offset;
  cx=cursor_x;
  cy=cursor_y;

  for (x=1;x <= num_lines;x++)
  {
    for (s=screen[x]+1;*s;s++)
    {
      if (isalpha(*s))
      {
        o=s;

        p=temp;

        while (isalpha(*s) || *s=='\'')
          *p++=*s++;

        *p='\0';

        /* Make room for "ay" */
        memmove(s+2,s,strlen(s)+1);

        l=pig(temp,temp2);
        memmove(o,l,strlen(l));
        s++;

        if (s-(screen[x]+1)+strlen(l) >= usrwidth)
        {
          offset=x-1;
          cursor_x=1;
          cursor_y=strlen(screen[x]+1)+1;

          Word_Wrap(MODE_NOUPDATE);            /* Scroll if necessary */

          x=offset+cursor_x;
          s=screen[x];    /* the "s++" incs this later */

          if (x > num_lines || x > max_lines)
            break;
        }
      }
    }
  }

  offset=ofs;
  cursor_x=cx;
  cursor_y=cy;

  Redraw_Text();
}

static char * pig(char *s,char *temp)
{
  char *p;

  strcpy(temp,s+1);
  p=temp+strlen(temp);

  if (isupper(*s))
    *p++=tolower(*s);
  else *p++=*s;

  strcpy(p,"ay");

  if (isupper(*s))
    *temp=toupper(*temp);

  return temp;
}


